VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmImportFromAccess 
   Caption         =   "Import from Access"
   ClientHeight    =   5244
   ClientLeft      =   36
   ClientTop       =   324
   ClientWidth     =   6204
   OleObjectBlob   =   "frmImportFromAccess.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frmImportFromAccess"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim fld As Outlook.MAPIFolder
Dim strFolder As String

Private Sub cmdImport_Click()
'Created by Helen Feddema 9-10-2000
'Last modified 9-10-2000

On Error GoTo ErrorHandler

   Dim rst As DAO.Recordset
   Dim dbe As DAO.DBEngine
   Dim wks As DAO.Workspace
   Dim dbs As DAO.Database
   Dim nms As Outlook.NameSpace
   Dim itms As Outlook.Items
   Dim itm As Outlook.ContactItem
   Dim strAccessPath As String
   Dim appAccess As Access.Application
   Dim strFolder As String
   Dim fFound As Boolean
   Dim txt As MSForms.TextBox
   Dim strDBName As String
   Dim intRecCount As Integer
   
   Set nms = Application.GetNamespace("MAPI")
   strFolder = "Contacts from Access"
   Set txt = Me.txtProgress
   
   'Check for existence of Contacts from Access folder
   'and create it if not found
   fFound = FindFolder(nms.Folders("Personal Folders").Folders, 0, strFolder)

   If fFound = True Then
      Set fld = nms.Folders("Personal Folders").Folders(strFolder)
   ElseIf fFound = False Then
      Set fld = nms.Folders("Personal Folders").Folders.add(strFolder, olFolderContacts)
   End If

   'Pick up path to Access database directory from Access SysCmd function
   Set appAccess = CreateObject("Access.Application")
   strAccessPath = appAccess.SysCmd(9)
   strDBName = strAccessPath & "Contacts 2000.mdb"
   txt.Value = "Database name: " & strDBName
   
   'Use Office 2000 DAO version
   Set dbe = CreateObject("DAO.DBEngine.36")
   Set wks = dbe.Workspaces(0)
   Set dbs = wks.OpenDatabase(strDBName)

   'Open Access table containing data to import into Outlook
   Set rst = dbs.OpenRecordset("tblCustomers")
   intRecCount = rst.RecordCount
   If intRecCount = 0 Then
      txt.Value = vbCrLf & "No contacts to import"
      Exit Sub
   Else
      txt.Value = vbCrLf & intRecCount & " contacts to import"
   End If

   'Set up the Outlook folder and items and iterate
   'through the Access table, adding one contact item using
   'the custom form for each Access record

   Set itms = fld.Items

   Do Until rst.EOF
      txt.Value = vbCrLf & "Importing " & rst!ContactName & "'s record"
      Set itm = itms.add("IPM.Contact.Access Contact")

      'Built-in Outlook properties
      If IsNull(rst!CustomerID) = False Then itm.CustomerID = rst!CustomerID
      If IsNull(rst!CompanyName) = False Then itm.CompanyName = rst!CompanyName
      If IsNull(rst!ContactName) = False Then itm.FullName = rst!ContactName
      If IsNull(rst!Address) = False Then itm.BusinessAddressStreet = rst!Address
      If IsNull(rst!City) = False Then itm.BusinessAddressCity = rst!City
      If IsNull(rst!Region) = False Then itm.BusinessAddressState = rst!Region
      If IsNull(rst!PostalCode) = False Then itm.BusinessAddressPostalCode = rst!PostalCode
      If IsNull(rst!Country) = False Then itm.BusinessAddressCountry = rst!Country
      If IsNull(rst!Phone) = False Then itm.BusinessTelephoneNumber = rst!Phone
      If IsNull(rst!Fax) = False Then itm.BusinessFaxNumber = rst!Fax
      If IsNull(rst!ContactTitle) = False Then itm.JobTitle = rst!ContactTitle

      'Custom Outlook properties
      itm.UserProperties("Preferred") = rst!Preferred
      itm.UserProperties("Discount") = rst!Discount
      itm.Close (0)
      rst.MoveNext
      
   Loop
   rst.Close
   txt.Value = vbCrLf & "All contacts imported!"

ErrorHandlerExit:
   Exit Sub

ErrorHandler:
   MsgBox "Error No: " & Err.Number & "; Description: " & Err.Description
   Resume ErrorHandlerExit

End Sub
 
Function FindFolder(fldsParent As Folders, intDepth As Integer, _
   strShortName As String) As Boolean

   Dim strRoot As String

   strRoot = "Personal"
      For Each fld In fldsParent
      If fld.Name = strFolder Then
         FindFolder = True
         Exit Function
      End If
   Next

End Function
